//version 4

[UPDATE-MONITOR-SCHEMA-4]
//DB2_Monitor_Migration_From_423FP1_To_4232 (schema :4==>42)
CREATE INDEX "$SCHEMA$"."PT_AUTO_DEL_PID" ON "$SCHEMA$"."PROCESS"("PT_AUTO_DEL_PERIOD", "PT_PID");

CREATE INDEX "$SCHEMA$"."PI_COMP_PTID_PIID" ON "$SCHEMA$"."PROCESS_INST"("PI_COMPLETE_TIME", "PI_PROCESS_PTID", "PI_PIID");

//DB2_Monitor_Migration_From_4232_To_Latest (schema : ignored)7
ALTER TABLE "$SCHEMA$"."PROCESS_MODEL" ADD "PM_LAST_UPDATED" DECIMAL(16,0) DEFAULT 0;

CREATE INDEX "$SCHEMA$"."PI_STATE_AIID" ON "$SCHEMA$"."PROCESS_INST"("PI_STATE", "PI_PARENT_AIID");

[UPDATE-EQ-SCHEMA-4]
//DB2_EQ_Migration_From_423FP1_To_4232 (schema :4==>42)
CREATE SEQUENCE "$SCHEMA$"."EVENT_SEQUENCE" AS DECIMAL(16,0) START WITH 1 INCREMENT BY 1 NO MAXVALUE ORDER;

ALTER TABLE "$SCHEMA$"."HS_AUDIT_TRAIL" ADD "EVENT_SEQ" DECIMAL(16,0);

DROP INDEX "$SCHEMA$"."HS_ADT_TRL_INDEX";

CREATE INDEX "$SCHEMA$"."HS_ADT_TRL_INDEX" ON "$SCHEMA$"."HS_AUDIT_TRAIL"("CREATED", "EVENT");

CREATE INDEX "$SCHEMA$"."HS_AT_SEQ_INDEX" ON "$SCHEMA$"."HS_AUDIT_TRAIL"("EVENT_SEQ");

CREATE INDEX "$SCHEMA$"."HS_PD_TIME_INDEX" ON "$SCHEMA$"."HS_PROC_DATA"("LAST_UPDATED");

CREATE INDEX "$SCHEMA$"."HS_PDD_TIME_INDEX" ON "$SCHEMA$"."HS_CONT_DETAIL"("CD_LAST_UPDATED");

DROP TRIGGER "$SCHEMA$"."AT_INST";

CREATE TRIGGER "$SCHEMA$"."AT_INST" AFTER INSERT ON "$SCHEMA$"."AUDIT_TRAIL"
REFERENCING NEW AS NEW_REC
FOR EACH ROW 
 MODE DB2SQL
BEGIN ATOMIC
INSERT INTO $SCHEMA$.HS_AUDIT_TRAIL
(EVENT_SEQ, CREATED, EVENT, TEMPL_VALID_FROM, PROCESS_NAME, PROCESS_ID, TOP_LVL_PROC_NAME,
TOP_LVL_PROC_ID, PARENT_PROC_NAME, PARENT_PROC_ID, PROC_TEMPL_NAME, BLOCK_NAMES,
 USER_NAME,
SECOND_USER_NAME, ACTIVITY_NAME, ACTIVITY_TYPE, ACTIVITY_STATE,
 COMMAND_PARAMETERS, PROGRAM_NAME,
ACTIVITY_RC, ASSOCIATED_OBJECT,
 OBJECT_DESCRIPTION, SECOND_ACT_NAME)
VALUES
(NEXTVAL FOR $SCHEMA$.EVENT_SEQUENCE, NEW_REC.CREATED, NEW_REC.EVENT, NEW_REC.TEMPL_VALID_FROM,
NEW_REC.PROCESS_NAME, NEW_REC.PROCESS_ID, NEW_REC.TOP_LVL_PROC_NAME,
 NEW_REC.TOP_LVL_PROC_ID,
NEW_REC.PARENT_PROC_NAME, NEW_REC.PARENT_PROC_ID,
 NEW_REC.PROC_TEMPL_NAME, NEW_REC.BLOCK_NAMES,
NEW_REC.USER_NAME,
 NEW_REC.SECOND_USER_NAME, NEW_REC.ACTIVITY_NAME, NEW_REC.ACTIVITY_TYPE,
NEW_REC.ACTIVITY_STATE, NEW_REC.COMMAND_PARAMETERS, NEW_REC.PROGRAM_NAME,
 NEW_REC.ACTIVITY_RC,
NEW_REC.ASSOCIATED_OBJECT, NEW_REC.OBJECT_DESCRIPTION,
 NEW_REC.SECOND_ACT_NAME);
END
;

//DB2_EQ_Migration_From_4232_To_Latest (schema : ignored)
DROP INDEX "$SCHEMA$"."HS_ADT_TRL_INDEX";

ALTER TABLE "$SCHEMA$"."HS_PROC_DATA" ADD "PROC_DATA_SEQ" DECIMAL(16,0) DEFAULT 0 NOT NULL;

ALTER TABLE "$SCHEMA$"."HS_CONT_DETAIL" ADD "CONT_DETAIL_SEQ" DECIMAL(16,0) DEFAULT 0 NOT NULL;

//version 42

[UPDATE-MONITOR-SCHEMA-42]

[UPDATE-EQ-SCHEMA-42]

//version 5

[UPDATE-MONITOR-SCHEMA-5]
//DB2-Monitor-Migration-From-424Base-To-424FP1 (schema : 5==>51)
CREATE INDEX "$SCHEMA$"."PT_AUTO_DEL_PID" ON "$SCHEMA$"."PROCESS"("PT_AUTO_DEL_PERIOD", "PT_PID")

CREATE INDEX "$SCHEMA$"."PI_COMP_PTID_PIID" ON "$SCHEMA$"."PROCESS_INST"("PI_COMPLETE_TIME", "PI_PROCESS_PTID", "PI_PIID")

CREATE INDEX "$SCHEMA$"."PI_STATE_AIID" ON "$SCHEMA$"."PROCESS_INST"("PI_STATE", "PI_PARENT_AIID")

RENAME TABLE "$SCHEMA$"."EVENTS" TO EVENTS_BACK

DROP INDEX "$SCHEMA$"."EVENT_CONTEXTID"

CREATE TABLE "$SCHEMA$"."EVENTS"(
"EVENTID" CHAR(16) FOR BIT DATA NOT NULL,
"QUEUEID" INTEGER NOT NULL,
"EVENT_SEQ" DECIMAL(16,0) NOT NULL,
"EVENT_TIME" DECIMAL(16,0) NOT NULL,
"EVENT_CODE" INTEGER NOT NULL,
"CONTEXTID" CHAR(16) FOR BIT DATA NOT NULL,
"ENGINETYPE" VARCHAR(75) NOT NULL,
"ENGINEID" CHAR(16) FOR BIT DATA NOT NULL,
"EVENT_TIME_FRAC" INTEGER NOT NULL,
"SHORT_DATA" VARCHAR(1900) FOR BIT DATA,
CONSTRAINT "PK_EVENTS" PRIMARY KEY ("EVENTID"),
CONSTRAINT "EVENT_QUEUEID" UNIQUE("QUEUEID", "EVENT_SEQ")
) 

CREATE INDEX "$SCHEMA$"."EVENT_CONTEXTID" ON "$SCHEMA$"."EVENTS"("QUEUEID", "CONTEXTID")

CREATE TABLE "$SCHEMA$"."EVENT_DATA"(
"QUEUEID" INTEGER NOT NULL,
"EVENT_SEQ" DECIMAL(16,0) NOT NULL,
"DATA_SEQ" INTEGER NOT NULL,
"DATA" VARCHAR(1900) FOR BIT DATA,
CONSTRAINT "PK_EVENT_DATA" PRIMARY KEY ("QUEUEID", "EVENT_SEQ", "DATA_SEQ")
) 

DROP TABLE "$SCHEMA$"."DELAYED_EVENTS"

CREATE TABLE "$SCHEMA$"."DELAYED_EVENTS"(
"EVENTID" CHAR(16) FOR BIT DATA NOT NULL,
"QUEUEID" INTEGER NOT NULL,
"EVENT_SEQ" DECIMAL(16,0) NOT NULL,
"EVENT_TIME" DECIMAL(16,0) NOT NULL,
"EVENT_CODE" INTEGER NOT NULL,
"CONTEXTID" CHAR(16) FOR BIT DATA NOT NULL,
"ENGINETYPE" VARCHAR(75) NOT NULL,
"ENGINEID" CHAR(16) FOR BIT DATA NOT NULL,
"EVENT_TIME_FRAC" INTEGER NOT NULL,
"SHORT_DATA" VARCHAR(1900) FOR BIT DATA,
"TRIAL_NUMBER" INTEGER DEFAULT 0 NOT NULL,
CONSTRAINT "PK_DEVENTS" PRIMARY KEY ("EVENTID"),
CONSTRAINT "DELAYED_QUEUEID" UNIQUE("QUEUEID", "EVENT_SEQ", "TRIAL_NUMBER")
) 

CREATE INDEX "$SCHEMA$"."DELAYED_CONTEXTID" ON "$SCHEMA$"."DELAYED_EVENTS"("CONTEXTID")

RENAME TABLE "$SCHEMA$"."LOCK_TABLE" TO EB_SYNC_TABLE

CREATE TABLE "$SCHEMA$"."MQWF_SYNC_TABLE"(
"LOCKER" INTEGER DEFAULT 0 NOT NULL
) 

CREATE TABLE "$SCHEMA$"."WMQI_SYNC_TABLE"(
"LOCKER" INTEGER DEFAULT 0 NOT NULL
) 

CREATE TABLE "$SCHEMA$"."ICS_SYNC_TABLE"(
"LOCKER" INTEGER DEFAULT 0 NOT NULL
)

CREATE TABLE "$SCHEMA$"."CLEANUP_SYNC_TABLE"(
"LOCKER" INTEGER DEFAULT 0 NOT NULL
) 

CREATE TABLE "$SCHEMA$"."NOTIFY_SYNC_TABLE"(
"LOCKER" INTEGER DEFAULT 0 NOT NULL
) 

CREATE TABLE "$SCHEMA$"."CXFLOWEVENTRECORDS"(
"SEQUENCENUMBER" DECIMAL(16,0) NOT NULL,
"EVENT" VARCHAR(255) NOT NULL,
"MONITORFLOWID" VARCHAR(255) NOT NULL,
"OUTBOUNDFLOWID" VARCHAR(255) NOT NULL,
"TIMESTAMP" DECIMAL(16,0) NOT NULL,
"COMPONENTNAME" VARCHAR(80) NOT NULL,
"COMPONENTTYPE" INTEGER,
CONSTRAINT "EVENTINDEX" UNIQUE("SEQUENCENUMBER")
) 

CREATE TRIGGER "$SCHEMA$"."CX_INST" NO CASCADE BEFORE INSERT ON "$SCHEMA$"."CXFLOWEVENTRECORDS"
REFERENCING NEW AS NEW_REC FOR EACH ROW
MODE DB2SQL BEGIN ATOMIC
SET NEW_REC.TIMESTAMP = (1000. * (((DAYS(CURRENT TIMESTAMP) - DAYS('1970-01-01')) * 86400.) + MIDNIGHT_SECONDS(CURRENT TIMESTAMP))) + (MICROSECOND(CURRENT TIMESTAMP)/1000);
END
 
ALTER TABLE "$SCHEMA$"."PROCESS_MODEL" ADD PM_LAST_UPDATED DECIMAL(16,0) DEFAULT 0

INSERT INTO $SCHEMA$.SYS_PROPERTIES VALUES('monitor.eventProcessor.count', '1')

[UPDATE-MONITOR-SCHEMA-5-AFTER-JAVA-CODE-EXECUTION]
DROP TABLE "$SCHEMA$"."EVENTS_BACK"

[UPDATE-EQ-SCHEMA-5]
//DB2-EQ-Migration-From-424Base-To-424FP1 (schema : 5==>51)
CREATE SEQUENCE "$SCHEMA$"."EVENT_SEQUENCE" AS DECIMAL(16,0) START WITH 1 INCREMENT BY 1 NO MAXVALUE ORDER

DROP INDEX "$SCHEMA$"."HS_ADT_TRL_INDEX"

CREATE INDEX "$SCHEMA$"."HS_AT_SEQ_INDEX" ON "$SCHEMA$"."HS_AUDIT_TRAIL"("EVENT_SEQ")

DROP TRIGGER "$SCHEMA$"."AT_INST"

CREATE TRIGGER "$SCHEMA$"."AT_INST" AFTER INSERT ON "$SCHEMA$"."AUDIT_TRAIL"
 REFERENCING NEW AS NEW_REC FOR EACH ROW
 MODE DB2SQL BEGIN ATOMIC
 INSERT INTO $SCHEMA$.HS_AUDIT_TRAIL
 (EVENT_SEQ, CREATED, EVENT, TEMPL_VALID_FROM, PROCESS_NAME, PROCESS_ID, TOP_LVL_PROC_NAME,
 TOP_LVL_PROC_ID, PARENT_PROC_NAME, PARENT_PROC_ID, PROC_TEMPL_NAME, BLOCK_NAMES,
 USER_NAME, SECOND_USER_NAME, ACTIVITY_NAME, ACTIVITY_TYPE, ACTIVITY_STATE,
 COMMAND_PARAMETERS, PROGRAM_NAME, ACTIVITY_RC, ASSOCIATED_OBJECT,
 OBJECT_DESCRIPTION, SECOND_ACT_NAME, EXTERNAL_CONTEXT)
 VALUES
 (NEXTVAL FOR $SCHEMA$.EVENT_SEQUENCE, NEW_REC.CREATED, NEW_REC.EVENT, NEW_REC.TEMPL_VALID_FROM,
 NEW_REC.PROCESS_NAME, NEW_REC.PROCESS_ID, NEW_REC.TOP_LVL_PROC_NAME,
 NEW_REC.TOP_LVL_PROC_ID, NEW_REC.PARENT_PROC_NAME, NEW_REC.PARENT_PROC_ID,
 NEW_REC.PROC_TEMPL_NAME, NEW_REC.BLOCK_NAMES, NEW_REC.USER_NAME,
 NEW_REC.SECOND_USER_NAME, NEW_REC.ACTIVITY_NAME, NEW_REC.ACTIVITY_TYPE,
 NEW_REC.ACTIVITY_STATE, NEW_REC.COMMAND_PARAMETERS, NEW_REC.PROGRAM_NAME,
 NEW_REC.ACTIVITY_RC, NEW_REC.ASSOCIATED_OBJECT, NEW_REC.OBJECT_DESCRIPTION,
 NEW_REC.SECOND_ACT_NAME, NEW_REC.EXTERNAL_CONTEXT);
 END
